Name:           nx
Version:        1.4.0
Release:	4.1.centos4
Summary:        Proxy system for X11

Group:          Applications/Internet
License:        GPL, Other uncritical OpenSource License
URL:            http://www.nomachine.com
Source0:	nxproxy-%{version}-2.tar.gz
Source1:	nxcomp-%{version}-31.tar.gz
Source2:	nxcompext-%{version}-3.tar.gz
Source3:	nx-X11-%{version}-10.tar.gz
Source4:	nxagent-%{version}-65.tar.gz
Source5:	nxviewer-%{version}-4.tar.gz
Source6:	nxdesktop-%{version}-61.tar.gz
Source7:	nxscripts-%{version}-3.tar.gz
Source8:	nxagent
Source9:	docs.tar.bz2
Patch0:		NX.diff
Patch1:		NX-noansi.diff
Patch2:		p_XFree86-4.3-ppc64.diff

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	gcc-c++
BuildRequires:  expat-devel audiofile-devel openssl-devel libjpeg-devel libpng-devel xorg-x11-devel xorg-x11-deprecated-libs
#BuildRequires:  expat-devel audiofile-devel openssl-devel libjpeg-devel libpng-devel XFree86-devel XFree86-libXp
Requires:	xorg-x11 xorg-x11-tools
#Requires:	XFree86 XFree86-tools
%description
NX provides a proxy system for the X Window System.

%prep
%setup -q -c %{name}-%{version} -T -a0 -a1 -a2 -a3 -a4 -a5 -a6 -a7
%patch0
%ifarch ia64
pushd nx-X11
%patch1
popd
%endif
%ifarch ppc64
pushd nx-X11
%patch2 -p1
popd
%endif
ln -s rdesktop.1 nxdesktop/doc/nxdesktop.1
cat >> nx-X11/config/cf/host.def << EOF
#ifdef  i386Architecture
#undef  DefaultGcc2i386Opt
#define DefaultGcc2i386Opt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  MipsArchitecture
#undef  DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef s390xArchitecture
#undef OptimizedCDebugFlags
#define OptimizedCDebugFlags $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
EOF

%build
%ifarch x86_64
export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -fPIC"
%else
export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"
%endif
#perl -pi -e"s|^CFLAGS=.*|CFLAGS=$CFLAGS|" */configure
perl -pi -e"s|CXXFLAGS=.-O.*|CXXFLAGS=$CXXFLAGS|" */configure
# build Compression Library and Proxy
for i in nxcomp nxproxy; do
  pushd $i; ./configure; make; popd
done
# build X11 Support Libraries and Agents
pushd nx-X11
  make World
popd
# build Extended Compression Library
pushd nxcompext
  ./configure; make
popd
# build RFB Agent
pushd nxviewer
  xmkmf -a
  cp -a /usr/X11R6/%{_lib}/libXp.so* ../nx-X11/exports/lib/
  make 2> /dev/null
popd
# build RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  ./configure --prefix=%{_prefix} --sharedir=%{_datadir}/NX
  make
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/NX/lib
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
# install X11 Support Libraries and Agents
cp -a nx-X11/lib/X11/libX11.so.* \
      nx-X11/lib/Xext/libXext.so.* \
      nx-X11/lib/Xrender/libXrender.so.* \
      $RPM_BUILD_ROOT/%{_libdir}/NX/lib
install -m 755 nx-X11/programs/Xserver/nxagent \
  $RPM_BUILD_ROOT/%{_libdir}/NX
install -m 755 $RPM_SOURCE_DIR/nxagent $RPM_BUILD_ROOT/%{_bindir}
# install Compression Libraries and Proxy
cp -a nxcomp/libXcomp.so.* $RPM_BUILD_ROOT/%{_libdir}/NX/lib
cp -a nxcompext/libXcompext.so.* $RPM_BUILD_ROOT/%{_libdir}/NX/lib
install -m 755 nxproxy/nxproxy $RPM_BUILD_ROOT/%{_libdir}/NX
ln -snf nxagent $RPM_BUILD_ROOT/%{_bindir}/nxproxy
# install RFB Agent
pushd nxviewer
  make install DESTDIR=$RPM_BUILD_ROOT
  mv $RPM_BUILD_ROOT/usr/X11R6/bin/nxviewer $RPM_BUILD_ROOT/%{_libdir}/NX
  ln -snf nxagent $RPM_BUILD_ROOT/%{_bindir}/nxviewer
  chmod 755 $RPM_BUILD_ROOT/%{_bindir}/nxviewer
  mv $RPM_BUILD_ROOT/usr/X11R6/bin/nxpasswd $RPM_BUILD_ROOT/%{_bindir}
popd
# install RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  make install DESTDIR=$RPM_BUILD_ROOT
  mv $RPM_BUILD_ROOT/%{_bindir}/nxdesktop $RPM_BUILD_ROOT/%{_libdir}/NX
  ln -snf nxagent $RPM_BUILD_ROOT/%{_bindir}/nxdesktop
  chmod 755 $RPM_BUILD_ROOT/%{_bindir}/nxdesktop
  mv $RPM_BUILD_ROOT/usr/man/man1/nxdesktop.1 \
     $RPM_BUILD_ROOT/%{_mandir}/man1/nxdesktop.1
  rm -rf $RPM_BUILD_ROOT/usr/man
popd
%endif
# install scripts
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
cp -r nxscripts $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
# documentation and license
tar xjf $RPM_SOURCE_DIR/docs.tar.bz2 -C $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
install -m 644 nxcomp/LICENSE   $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
for i in nxcomp nxdesktop; do
  mkdir $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/$i
done
install -m 644 nxcomp/README    $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/nxcomp
install -m 644 nxdesktop/README $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/nxdesktop
rm -rf nxdesktop/doc/CVS
cp -r nxdesktop/doc $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/nxdesktop


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc %{_datadir}/doc/packages/NX
%{_bindir}/*
%dir %{_libdir}/NX
%dir %{_libdir}/NX/lib
%{_libdir}/NX/*
%ifnarch ppc ppc64 s390 s390x
%dir %{_datadir}/NX
%{_mandir}/man1/nxdesktop.1.gz
%{_datadir}/NX/keymaps-windows/
%endif

%changelog
* Sat May  7 2005 Johnny Hughes <johnny@centos.org> - 1.4.0-4.1.centos4
- Modified to work with xorg-x11 instead of XFree86
- built to work with CentOS-4

* Mon Feb 14 2005 Rick Stout <zipsonic[AT]gmail.com> - 4:1.4.0
- updated nx-X11, nxproxy, nxcomp, nxagent and nxdesktop
- released to address X11 security concerns.
* Tue Nov 09 2004 Rick Stout <zipsonci[AT]gmail.com> - 3:1.4.0
- updated to 1.4.0 final
* Mon Oct 11 2004 Rick Stout <zipsonic[AT]gmail.com> - 2:1.4.0
- Changed naming structure to be more friendly (lowercase)
* Fri Oct 07 2004 Rick Stout <zipsonic[AT]gmail.com> - 1:1.4.0
- Updated package dependencies
* Wed Sep 29 2004 Rick Stout <zipsonic[AT]gmail.com> - 0:1.4.0
- Initial Fedora RPM release.
- Updated SuSE package to work with Fedora
